Index: undation/ga/storm_surge/parallel/netherlands.py
===================================================================
--- /inundation/ga/storm_surge/parallel/netherlands.py	(revision 1280)
+++ 	(revision )
@@ -1,162 +1,0 @@
-import sys
-from os import sep
-sys.path.append('..'+sep+'pyvolution')
-
-
-"""Example of shallow water wave equation.
-
-This is called Netherlands because it shows a dam with a gap in it and
-stylised housed behind it and below the water surface.
-
-"""
-
-######################
-# Module imports
-#
-from shallow_water import Domain, Reflective_boundary, Dirichlet_boundary,\
-     Transmissive_boundary, Constant_height
-
-from mesh_factory import rectangular
-from Numeric import array
-
-
-class Weir:
-    """Set a bathymetry for simple weir with a hole.
-    x,y are assumed to be in the unit square
-    """
-
-    def __init__(self, stage):
-        self.inflow_stage = stage
-
-    def __call__(self, x, y):
-        from Numeric import zeros, Float
-
-        N = len(x)
-        assert N == len(y)
-
-        z = zeros(N, Float)
-        for i in range(N):
-            z[i] = -x[i]/20  #General slope
-
-            #Flattish bit to the left
-            if x[i] <= 0.3:
-                #z[i] = -x[i]/5
-                z[i] = -x[i]/20
-
-
-            #Weir
-            if x[i] > 0.3 and x[i] < 0.4:
-                z[i] = -x[i]/20+1.2
-
-            #Dip
-            #if x[i] > 0.6 and x[i] < 0.9:
-            #    z[i] = -x[i]/20-0.5  #-y[i]/5
-
-            #Hole in weir
-            #if x[i] > 0.3 and x[i] < 0.4 and y[i] > 0.2 and y[i] < 0.4:
-            if x[i] > 0.3 and x[i] < 0.4 and y[i] > 0.4 and y[i] < 0.6:
-                #z[i] = -x[i]/5
-                z[i] = -x[i]/20
-
-            #Poles
-            #if x[i] > 0.65 and x[i] < 0.8 and y[i] > 0.55 and y[i] < 0.65 or\
-            #       x[i] > 0.75 and x[i] < 0.9 and y[i] > 0.35 and y[i] < 0.45:
-            #    z[i] = -x[i]/20+0.4
-
-            if (x[i] - 0.72)**2 + (y[i] - 0.6)**2 < 0.05**2:# or\
-                   #x[i] > 0.75 and x[i] < 0.9 and y[i] > 0.35 and y[i] < 0.45:
-                z[i] = -x[i]/20+0.4
-
-            #Wall
-            if x[i] > 0.995:
-                z[i] = -x[i]/20+0.3
-
-        return z/2
-
-
-
-######################
-# Domain
-#
-
-
-N = 150 #size = 45000
-N = 130 #size = 33800
-N = 600 #Size = 720000
-N = 30
-
-#N = 15
-
-print 'Creating domain'
-#Create basic mesh
-points, vertices, boundary = rectangular(N, N)
-
-#Create shallow water domain
-domain = Domain(points, vertices, boundary)
-
-domain.check_integrity()
-domain.default_order = 2
-#domain.beta_h=0
-
-#Output params
-domain.smooth = False
-domain.reduction = min  #Looks a lot better on top of steep slopes
-
-print "Number of triangles = ", len(domain)
-
-
-if N > 150:
-    domain.visualise = False
-    domain.checkpoint = False
-    domain.store = True    #Store for visualisation purposes
-    domain.format = 'sww'   #Native netcdf visualisation format
-    import sys, os
-    #FIXME: This was os.path.splitext but caused weird filenames based on root
-    base = os.path.basename(sys.argv[0])
-    domain.filename, _ = os.path.splitext(base)
-else:
-    domain.visualise = True
-    domain.checkpoint = False
-    domain.store = False
-
-
-#Set bed-slope and friction
-inflow_stage = 0.1
-manning = 0.02
-Z = Weir(inflow_stage)
-
-print 'Field values'
-domain.set_quantity('elevation', Z)
-domain.set_quantity('friction', manning)
-
-
-######################
-# Boundary conditions
-#
-print 'Boundaries'
-Br = Reflective_boundary(domain)
-Bt = Transmissive_boundary(domain)
-
-#Constant inflow
-Bd = Dirichlet_boundary([2*inflow_stage, 0.0, 0.0])
-
-
-#Set boundary conditions
-domain.set_boundary({'left': Bd, 'right': Br, 'bottom': Br, 'top': Br})
-
-
-######################
-#Initial condition
-#
-print 'Initial condition'
-domain.set_quantity('stage', Constant_height(Z, 0.))
-
-#Evolve
-import time
-t0 = time.time()
-
-for t in domain.evolve(yieldstep = 0.01, finaltime = 10.0):
-    domain.write_time()
-
-
-print 'That took %.2f seconds' %(time.time()-t0)
Index: /inundation/ga/storm_surge/pyvolution/realtime_visualisation_new.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/realtime_visualisation_new.py	(revision 1280)
+++ /inundation/ga/storm_surge/pyvolution/realtime_visualisation_new.py	(revision 1281)
@@ -19,5 +19,4 @@
         try:
             self.bed   = domain.quantities['elevation'].vertex_values
-
             self.xmomentum = domain.quantities['xmomentum'].vertex_values
             self.ymomentum = domain.quantities['ymomentum'].vertex_values
@@ -84,13 +83,11 @@
         c1 = 0.3
         c2 = 0.3
-        try:
+        if self.bed != None:
             self.update_arrays(self.bed,  (c0,c1,c2) )
-        except:
-            pass
-
-        #print 'update bed image'
-        self.bed_model.pos    = self.pos
-        self.bed_model.color  = self.colour
-        self.bed_model.normal = self.normals
+
+            #print 'update bed image'
+            self.bed_model.pos    = self.pos
+            self.bed_model.color  = self.colour
+            self.bed_model.normal = self.normals
 
 
@@ -100,9 +97,10 @@
         c2 = 0.99
         #print 'update stage arrays'
-        self.update_arrays(self.stage, (c0,c1,c2) )
-        #print 'update stage image'
-        self.stage_model.pos    = self.pos
-        self.stage_model.color  = self.colour
-        self.stage_model.normal = self.normals
+        if self.stage != None:
+            self.update_arrays(self.stage, (c0,c1,c2) )
+            #print 'update stage image'
+            self.stage_model.pos    = self.pos
+            self.stage_model.color  = self.colour
+            self.stage_model.normal = self.normals
 
     def update_xmomentum(self):
@@ -311,5 +309,5 @@
     domain.surface = surface
 
-    #surface.update_bed()
+    surface.update_bed()
     surface.update_stage()
     #surface.update_xmomentum()