Index: /inundation/ga/storm_surge/zeus/parallel.zpi
===================================================================
--- /inundation/ga/storm_surge/zeus/parallel.zpi	(revision 1282)
+++ /inundation/ga/storm_surge/zeus/parallel.zpi	(revision 1282)
@@ -0,0 +1,81 @@
+<!-- Project file for the Zeus for Windows editor.-->
+<project name="parallel">
+    <SccEnable>Off</SccEnable>
+    <SccComment></SccComment>
+    <SccProject></SccProject>
+    <SccAuxPath></SccAuxPath>
+    <SccLocalPath></SccLocalPath>
+    <TagEnable>On</TagEnable>
+    <TagNone>Off</TagNone>
+    <TagVariable>On</TagVariable>
+    <TagFunction>On</TagFunction>
+    <TagBuildNone>Off</TagBuildNone>
+    <TagBuildOnOpen>On</TagBuildOnOpen>
+    <TagBuildOnSave>On</TagBuildOnSave>
+    <TagInterval>6</TagInterval>
+    <Server></Server>
+    <UserID></UserID>
+    <Password></Password>
+    <LocalDir></LocalDir>
+    <RemoteDir></RemoteDir>
+    <Classes>Classes</Classes>
+    <Enumerations>Enumerations</Enumerations>
+    <Files>ProjectFiles</Files>
+    <Functions>Functions</Functions>
+    <Interfaces>Interfaces</Interfaces>
+    <Macros>Macros</Macros>
+    <Packages>Packages</Packages>
+    <References>References</References>
+    <Structures>Structures</Structures>
+    <Typedefs>Typedefs</Typedefs>
+    <Variables>Variables</Variables>
+    <MakeFile></MakeFile>
+    <SearchPath></SearchPath>
+    <RegexFile></RegexFile>
+    <RegexLine></RegexLine>
+    <RegexInfo></RegexInfo>
+    <RegexError></RegexError>
+    <RegexWarning></RegexWarning>
+    <DebugExecutable></DebugExecutable>
+    <DebugArguments></DebugArguments>
+    <DebugDirectory></DebugDirectory>
+    <DebugDebugger></DebugDebugger>
+    <ReleaseExecutable></ReleaseExecutable>
+    <ReleaseArguments></ReleaseArguments>
+    <ReleaseDirectory></ReleaseDirectory>
+    <ReleaseDebugger></ReleaseDebugger>
+    <DebugMake></DebugMake>
+    <DebugClean></DebugClean>
+    <DebugCompile></DebugCompile>
+    <DebugRebuild></DebugRebuild>
+    <DebugProjectOutput></DebugProjectOutput>
+    <DebugCompilerOutput></DebugCompilerOutput>
+    <DebugCompilerStdOut>On</DebugCompilerStdOut>
+    <DebugCompilerStdErr>On</DebugCompilerStdErr>
+    <DebugCompilerSaveAll>Off</DebugCompilerSaveAll>
+    <DebugCompilerReload>Off</DebugCompilerReload>
+    <DebugProjectStdOut>On</DebugProjectStdOut>
+    <DebugProjectStdErr>On</DebugProjectStdErr>
+    <DebugProjectSaveAll>Off</DebugProjectSaveAll>
+    <DebugProjectReload>Off</DebugProjectReload>
+    <ReleaseMake></ReleaseMake>
+    <ReleaseClean></ReleaseClean>
+    <ReleaseCompile></ReleaseCompile>
+    <ReleaseRebuild></ReleaseRebuild>
+    <ReleaseProjectOutput></ReleaseProjectOutput>
+    <ReleaseCompilerOutput></ReleaseCompilerOutput>
+    <ReleaseCompilerStdOut>On</ReleaseCompilerStdOut>
+    <ReleaseCompilerStdErr>On</ReleaseCompilerStdErr>
+    <ReleaseCompilerSaveAll>Off</ReleaseCompilerSaveAll>
+    <ReleaseCompilerReload>Off</ReleaseCompilerReload>
+    <ReleaseProjectStdOut>On</ReleaseProjectStdOut>
+    <ReleaseProjectStdErr>On</ReleaseProjectStdErr>
+    <ReleaseProjectSaveAll>Off</ReleaseProjectSaveAll>
+    <ReleaseProjectReload>Off</ReleaseProjectReload>
+    <file>..\parallel\advection.py</file>
+    <file>..\parallel\run_advection.py</file>
+    <file>..\parallel\test_advection.py</file>
+    <folder name="Header Files" />
+    <folder name="Resource Files" />
+    <folder name="Source Files" />
+</project>
Index: undation/ga/storm_surge/zeus/pyvolution-parallel.zpi
===================================================================
--- /inundation/ga/storm_surge/zeus/pyvolution-parallel.zpi	(revision 1281)
+++ 	(revision )
@@ -1,143 +1,0 @@
-<!-- Project file for the Zeus for Windows editor.-->
-<project name="pyvolution-parallel">
-    <SccEnable>On</SccEnable>
-    <SccComment></SccComment>
-    <SccProject></SccProject>
-    <SccAuxPath></SccAuxPath>
-    <SccLocalPath></SccLocalPath>
-    <TagEnable>On</TagEnable>
-    <TagNone>Off</TagNone>
-    <TagVariable>On</TagVariable>
-    <TagFunction>On</TagFunction>
-    <TagBuildNone>Off</TagBuildNone>
-    <TagBuildOnOpen>On</TagBuildOnOpen>
-    <TagBuildOnSave>On</TagBuildOnSave>
-    <TagInterval>6</TagInterval>
-    <Server></Server>
-    <UserID></UserID>
-    <Password></Password>
-    <LocalDir></LocalDir>
-    <RemoteDir></RemoteDir>
-    <Classes>Classes</Classes>
-    <Enumerations>Enumerations</Enumerations>
-    <Files>Project Files</Files>
-    <Functions>Functions</Functions>
-    <Interfaces>Interfaces</Interfaces>
-    <Macros>Macros</Macros>
-    <Packages>Packages</Packages>
-    <References>References</References>
-    <Structures>Structures</Structures>
-    <Typedefs>Typedefs</Typedefs>
-    <Variables>Variables</Variables>
-    <MakeFile>makefile</MakeFile>
-    <SearchPath></SearchPath>
-    <RegexFile></RegexFile>
-    <RegexLine></RegexLine>
-    <RegexInfo></RegexInfo>
-    <RegexError></RegexError>
-    <RegexWarning></RegexWarning>
-    <DebugExecutable></DebugExecutable>
-    <DebugArguments></DebugArguments>
-    <DebugDirectory></DebugDirectory>
-    <DebugDebugger></DebugDebugger>
-    <ReleaseExecutable></ReleaseExecutable>
-    <ReleaseArguments></ReleaseArguments>
-    <ReleaseDirectory></ReleaseDirectory>
-    <ReleaseDebugger></ReleaseDebugger>
-    <DebugMake>make $PF</DebugMake>
-    <DebugClean>make clean</DebugClean>
-    <DebugCompile></DebugCompile>
-    <DebugRebuild>make $PF</DebugRebuild>
-    <DebugProjectOutput>Always</DebugProjectOutput>
-    <DebugCompilerOutput>Always</DebugCompilerOutput>
-    <DebugCompilerStdOut>On</DebugCompilerStdOut>
-    <DebugCompilerStdErr>On</DebugCompilerStdErr>
-    <DebugCompilerSaveAll>Off</DebugCompilerSaveAll>
-    <DebugCompilerReload>Off</DebugCompilerReload>
-    <DebugProjectStdOut>On</DebugProjectStdOut>
-    <DebugProjectStdErr>On</DebugProjectStdErr>
-    <DebugProjectSaveAll>Off</DebugProjectSaveAll>
-    <DebugProjectReload>Off</DebugProjectReload>
-    <ReleaseMake>make $ws</ReleaseMake>
-    <ReleaseClean>make clean</ReleaseClean>
-    <ReleaseCompile></ReleaseCompile>
-    <ReleaseRebuild>rebuild $ws</ReleaseRebuild>
-    <ReleaseProjectOutput>Always</ReleaseProjectOutput>
-    <ReleaseCompilerOutput>Always</ReleaseCompilerOutput>
-    <ReleaseCompilerStdOut>On</ReleaseCompilerStdOut>
-    <ReleaseCompilerStdErr>On</ReleaseCompilerStdErr>
-    <ReleaseCompilerSaveAll>Off</ReleaseCompilerSaveAll>
-    <ReleaseCompilerReload>Off</ReleaseCompilerReload>
-    <ReleaseProjectStdOut>On</ReleaseProjectStdOut>
-    <ReleaseProjectStdErr>On</ReleaseProjectStdErr>
-    <ReleaseProjectSaveAll>Off</ReleaseProjectSaveAll>
-    <ReleaseProjectReload>Off</ReleaseProjectReload>
-    <file>..\pyvolution-parallel\advection.py</file>
-    <file>..\pyvolution-parallel\bed_w_eden_boundary.py</file>
-    <file>..\pyvolution-parallel\bed_w_file_boundary.py</file>
-    <file>..\pyvolution-parallel\cg_solve.py</file>
-    <file>..\pyvolution-parallel\check_sww_tsh.py</file>
-    <file>..\pyvolution-parallel\chris-dump.py</file>
-    <file>..\pyvolution-parallel\combine_pts.py</file>
-    <file>..\pyvolution-parallel\compile.py</file>
-    <file>..\pyvolution-parallel\config.py</file>
-    <file>..\pyvolution-parallel\cornell_room.py</file>
-    <file>..\pyvolution-parallel\data_manager.py</file>
-    <file>..\pyvolution-parallel\domain.py</file>
-    <file>..\pyvolution-parallel\flatbed.py</file>
-    <file>..\pyvolution-parallel\flatbed_compare.py</file>
-    <file>..\pyvolution-parallel\general_mesh.py</file>
-    <file>..\pyvolution-parallel\generic_boundary_conditions.py</file>
-    <file>..\pyvolution-parallel\interpolate_sww.py</file>
-    <file>..\pyvolution-parallel\island.py</file>
-    <file>..\pyvolution-parallel\least_squares.py</file>
-    <file>..\pyvolution-parallel\log.ini</file>
-    <file>..\pyvolution-parallel\mesh.py</file>
-    <file>..\pyvolution-parallel\mesh_factory.py</file>
-    <file>..\pyvolution-parallel\most2nc.py</file>
-    <file>..\pyvolution-parallel\netherlands.py</file>
-    <file>..\pyvolution-parallel\netherlands-chris.py</file>
-    <file>..\pyvolution-parallel\pmesh2domain.py</file>
-    <file>..\pyvolution-parallel\pressure_force.py</file>
-    <file>..\pyvolution-parallel\quad.py</file>
-    <file>..\pyvolution-parallel\quantity.py</file>
-    <file>..\pyvolution-parallel\quantity_ext.c</file>
-    <file>..\pyvolution-parallel\realtime_visualisation.py</file>
-    <file>..\pyvolution-parallel\region.py</file>
-    <file>..\pyvolution-parallel\run_profile.py</file>
-    <file>..\pyvolution-parallel\run_tsh_weir.py</file>
-    <file>..\pyvolution-parallel\shallow_water.py</file>
-    <file>..\pyvolution-parallel\shallow_water_ext.c</file>
-    <file>..\pyvolution-parallel\show_balanced_limiters.py</file>
-    <file>..\pyvolution-parallel\sparse.py</file>
-    <file>..\pyvolution-parallel\sparse_ext.c</file>
-    <file>..\pyvolution-parallel\test_advection.py</file>
-    <file>..\pyvolution-parallel\test_all.py</file>
-    <file>..\pyvolution-parallel\test_cg_solve.py</file>
-    <file>..\pyvolution-parallel\test_combine_pts.py</file>
-    <file>..\pyvolution-parallel\test_data_manager.py</file>
-    <file>..\pyvolution-parallel\test_domain.py</file>
-    <file>..\pyvolution-parallel\test_general_mesh.py</file>
-    <file>..\pyvolution-parallel\test_generic_boundary_conditions.py</file>
-    <file>..\pyvolution-parallel\test_interpolate_sww.py</file>
-    <file>..\pyvolution-parallel\test_least_squares.py</file>
-    <file>..\pyvolution-parallel\test_mesh.py</file>
-    <file>..\pyvolution-parallel\test_most2nc.py</file>
-    <file>..\pyvolution-parallel\test_pmesh2domain.py</file>
-    <file>..\pyvolution-parallel\test_quad.py</file>
-    <file>..\pyvolution-parallel\test_quantity.py</file>
-    <file>..\pyvolution-parallel\test_region.py</file>
-    <file>..\pyvolution-parallel\test_shallow_water.py</file>
-    <file>..\pyvolution-parallel\test_sparse.py</file>
-    <file>..\pyvolution-parallel\test_util.py</file>
-    <file>..\pyvolution-parallel\treenode.py</file>
-    <file>..\pyvolution-parallel\tsh2sww.py</file>
-    <file>..\pyvolution-parallel\twolevels.py</file>
-    <file>..\pyvolution-parallel\util.py</file>
-    <file>..\pyvolution-parallel\util_ext.c</file>
-    <file>..\pyvolution-parallel\util_ext.h</file>
-    <file>..\pyvolution-parallel\wind_example_variable.py</file>
-    <folder name="Header Files" />
-    <folder name="Resource Files" />
-    <folder name="Source Files" />
-</project>